/<?php

    // akinava@gmail.com

    $INFO = Array();

    $INFO['name'] = "delivery_dellin";
    $INFO['filename'] = "modules/delivery_dellin/class.php";
    $INFO['config'] = "0";
    $INFO['ico'] = "ico_delivery_dellin";
    $INFO['default_method'] = "tree";
    $INFO['default_method_admin'] = "tree";

    $INFO['func_perms'] = "";
    $INFO['func_perms/view'] = "Просмотр страниц модуля";
    $INFO['func_perms/admin'] = "Администрирование модуля";

    $COMPONENTS = array();

    $COMPONENTS[0] = "./classes/modules/delivery_dellin/class.php";
    $COMPONENTS[1] = "./classes/modules/delivery_dellin/__admin.php";
    $COMPONENTS[2] = "./classes/modules/delivery_dellin/lang.php";
    $COMPONENTS[3] = "./classes/modules/delivery_dellin/i18n.php";
    $COMPONENTS[4] = "./classes/modules/delivery_dellin/permissions.php";
    //echo '<prez>';
    // var_dump($_SERVER);

    $classes_dir = realpath(dirname(__FILE__) . '/../');
    // var_dump($classes_dir);
    copy($classes_dir.'/'.$INFO['name'].'/classes/delivery/systems/dellin.php',$classes_dir.'/emarket/classes/delivery/systems/dellin.php');
    // copy icons
    copy($classes_dir.'/'.$INFO['name'].'/icons/small/'.$INFO['name'].'.png',$classes_dir.'/../../images/cms/admin/mac/icons/small/'.$INFO['name'].'.png');
    copy($classes_dir.'/'.$INFO['name'].'/icons/medium/'.$INFO['name'].'.png',$classes_dir.'/../../images/cms/admin/mac/icons/medium/'.$INFO['name'].'.png');
    copy($classes_dir.'/'.$INFO['name'].'/icons/big/'.$INFO['name'].'.png',$classes_dir.'/../../images/cms/admin/mac/icons/big/'.$INFO['name'].'.png');

    $className = "dellin";
    $dellinName = "Доставка компанией ООО \"Деловые Линии\"";

    // защита от повторной установки
    $objectTypesCollection = umiObjectTypesCollection::getInstance();
    $typeId = $objectTypesCollection->getBaseType('emarket', 'delivery');
    $subTypes = $objectTypesCollection->getSubTypesList($typeId);
    foreach ($subTypes as $id) {
        $obj = $objectTypesCollection->getType($id);
        if ($obj->getName() == $dellinName) {
            return;
        }
    }

 
    // создание списка типов и сопоставление их с id (по идеи id меняться не должен, но страхуемся)
    $fieldTypesCollection = umiFieldTypesCollection::getInstance();
    $fieldTypesList = $fieldTypesCollection->getFieldTypesList();
    // Список ID типов полей
    $field_type_list = array('boolean' => null, 'int' => null, 'float' => null, 'string' => null);
    foreach($fieldTypesList as $fieldType) {
        foreach($field_type_list as $type=>$value){
            $dataType = $fieldType->getDataType();
            if($type == $dataType && empty($value)){
                $field_type_list[$type] = $fieldType->getId();
            }
        }
    }

    $objectsCollection = umiObjectsCollection::getInstance();
 
    // получаем родительский тип
    // Способы доставки в шаблонах/типах данных
    $parentTypeId = $objectTypesCollection->getTypeIdByGUID("emarket-delivery");
    // Тип для внутреннего объекта, связанного с публичным типом
    // Шаблоны данных справочник "Типы доставки"
    $internalTypeId = $objectTypesCollection->getTypeIdByGUID("emarket-deliverytype");
    // Шаблоны данных справочник "Типы доставки" - ИД нашего нового объекта
    $typeId = $objectTypesCollection->addType($parentTypeId, $dellinName);
    $dellinTypeObject = $objectTypesCollection->getType($typeId);

    // Набиваем справочник новыми типами полей
    $fieldsCollection = umiFieldsCollection::getInstance();
    //$fieldId = $fieldsCollection->addField($name, $title, $field_type_id);

    // $fieldTypesCollection = umiFieldTypesCollection::getInstance();

    // api key
    $apiKeyFieldId = $fieldsCollection->addField('api_key', 'API KEY (Для получения API KEY зарегистрируйте приложение на сайте http://dev.dellin.ru/register/app)', $field_type_list['string']);
    // ссылка API
    $apiUrlFieldId = $fieldsCollection->addField('api', 'API URL', $field_type_list['string']);

    // адрес склада магазина
    $storageCLADR = $fieldsCollection->addField('derival_point', 'Код КЛАДР, адрес магазина', $field_type_list['string']);
    // адрес терминала выдачи
    //$terminalCLADR = $fieldsCollection->addField('arrival_point', 'код КЛАДР, адрес терминала ООО Деловые линии', $field_type_list['string']);
    
    // наценка
    $marginRelativeFieldId = $fieldsCollection->addField('margin_relative', 'Наценка относительная %', $field_type_list['float']);
    $marginAbsoluteFieldId = $fieldsCollection->addField('margin_absolute', 'Наценка абсолютная руб.', $field_type_list['float']);
    
    // страховка
    //$notInsureFieldId = $fieldsCollection->addField('not_insure', 'Не страховать груз', $field_type_list['boolean']);
    $insuranceFieldId = $fieldsCollection->addField('insurance', 'Застраховать груз с заявленной стоимостью? Без заявления стоимости грузы страхуются по ставке 95 руб. (35 руб. при мин. стоимости перевозки)', $field_type_list['boolean']);
    
    // доставка
    //$storageCLADR = $fieldsCollection->addField('storage_cladr', 'адрес склада (код КЛАДР)', $field_type_list['string']);
    //$terminalCLADR = $fieldsCollection->addField('terminal_cladr', 'адрес терминала выдачи (код КЛАДР)', $field_type_list['string']);
    
    // упаковка 
    $sturdyPackagingFieldId = $fieldsCollection->addField('sturdy_packaging', 'Жесткая упаковка', $field_type_list['boolean']);
    $additionalPackagingFieldId = $fieldsCollection->addField('additional_packaging', 'Дополнительная упаковка', $field_type_list['boolean']);
    $bubblePackagingFieldId = $fieldsCollection->addField('bubble_packaging', 'Пузырьковая упаковка', $field_type_list['boolean']);
    $sackPackagingFieldId = $fieldsCollection->addField('sack_packaging', 'Упаковка в мешок', $field_type_list['boolean']);
    $palletBoardFieldId = $fieldsCollection->addField('pallet_board', 'Паллетный борт', $field_type_list['boolean']);

    // загрузка на складе магазина
    $driveToClientFieldId = $fieldsCollection->addField('drive_to_client', 'Нужен ли отвоз груза до клиента?', $field_type_list['boolean']);
    $storageLateralLoadingFieldId = $fieldsCollection->addField('lateral_loading_on_storage', 'Нужна ли боковая погрузка?', $field_type_list['boolean']);
    $storageTopLoadingFieldId = $fieldsCollection->addField('top_loading_on_storage', 'Нужна ли верхняя погрузка?', $field_type_list['boolean']);
    $storageNeedLiftLoadingFieldId = $fieldsCollection->addField('need_lift_on_storage', 'Нужен ли гидроборт для погрузки?', $field_type_list['boolean']);
    $storageNeedManipulatorLoadingFieldId = $fieldsCollection->addField('need_manipulator_on_storage', 'Нужен ли манипулятор для погрузки?', $field_type_list['boolean']);
    $storageNeedOpenCarLoadingFieldId = $fieldsCollection->addField('need_open_car_on_storage', 'Нужна ли открытая машина для погрузки?', $field_type_list['boolean']);
    $storageNeedTentFieldId = $fieldsCollection->addField('need_tent_on_storage', 'Нужна ли растентовка при погрузке?', $field_type_list['boolean']);

    // выгрузка на стороне клиента
    $takeInShopFieldId = $fieldsCollection->addField('take_in_shop', 'Нужен ли забор груза в магазине?', $field_type_list['boolean']);
    $clientLateralLoadingFieldId = $fieldsCollection->addField('lateral_unloading_on_client', 'Нужна ли боковая выгрузка?', $field_type_list['boolean']);
    $clientTopLoadingFieldId = $fieldsCollection->addField('top_unloading_on_client', 'Нужна ли верхняя выгрузка?', $field_type_list['boolean']);
    $clientNeedLiftLoadingFieldId = $fieldsCollection->addField('need_lift_on_client', 'Нужен ли гидроборт для выгрузки?', $field_type_list['boolean']);
    $clientNeedManipulatorLoadingFieldId = $fieldsCollection->addField('need_manipulator_on_client', 'Нужен ли манипулятор для выгрузки?', $field_type_list['boolean']);
    $clientNeedOpenCarLoadingFieldId = $fieldsCollection->addField('need_open_car_on_client', 'Нужна ли открытая машина для выгрузки?', $field_type_list['boolean']);
    $clientNeedTentFieldId = $fieldsCollection->addField('need_tent_on_client', 'Нужна ли растентовка при выгрузке?', $field_type_list['boolean']);

    // получение группы "common"
    $dellinTypeObjectCommonGroup = $dellinTypeObject->getFieldsGroupByName('delivery_description_props');

    // добавим поле в группу
    $dellinTypeObjectCommonGroup->attachField($apiKeyFieldId);
    $dellinTypeObjectCommonGroup->attachField($apiUrlFieldId);

    $dellinTypeObjectCommonGroup->attachField($storageCLADR);
    //$dellinTypeObjectCommonGroup->attachField($terminalCLADR);

    $dellinTypeObjectCommonGroup->attachField($marginRelativeFieldId);
    $dellinTypeObjectCommonGroup->attachField($marginAbsoluteFieldId);

    //$dellinTypeObjectCommonGroup->attachField($notInsureFieldId);
    $dellinTypeObjectCommonGroup->attachField($insuranceFieldId);
    $dellinTypeObjectCommonGroup->attachField($takeInShopFieldId);
    $dellinTypeObjectCommonGroup->attachField($driveToClientFieldId);
    $dellinTypeObjectCommonGroup->attachField($sturdyPackagingFieldId);
    $dellinTypeObjectCommonGroup->attachField($additionalPackagingFieldId);
    $dellinTypeObjectCommonGroup->attachField($bubblePackagingFieldId);
    $dellinTypeObjectCommonGroup->attachField($sackPackagingFieldId);
    $dellinTypeObjectCommonGroup->attachField($palletBoardFieldId);

    $dellinTypeObjectCommonGroup->attachField($storageLateralLoadingFieldId);
    $dellinTypeObjectCommonGroup->attachField($storageTopLoadingFieldId);
    $dellinTypeObjectCommonGroup->attachField($storageNeedLiftLoadingFieldId);
    $dellinTypeObjectCommonGroup->attachField($storageNeedManipulatorLoadingFieldId);
    $dellinTypeObjectCommonGroup->attachField($storageNeedOpenCarLoadingFieldId);
    $dellinTypeObjectCommonGroup->attachField($storageNeedTentFieldId);

    $dellinTypeObjectCommonGroup->attachField($clientLateralLoadingFieldId);
    $dellinTypeObjectCommonGroup->attachField($clientTopLoadingFieldId);
    $dellinTypeObjectCommonGroup->attachField($clientNeedLiftLoadingFieldId);
    $dellinTypeObjectCommonGroup->attachField($clientNeedManipulatorLoadingFieldId);
    $dellinTypeObjectCommonGroup->attachField($clientNeedOpenCarLoadingFieldId);
    $dellinTypeObjectCommonGroup->attachField($clientNeedTentFieldId); 
    // Создаем внутренний объект
    // ИД нашего элемента в справочнике
    $deliveryDellineObjectId = $objectsCollection->addObject($dellinName, $internalTypeId);
    // находим элемент (экземпляр класса)
    $deliveryDellineObject = $objectsCollection->getObject($deliveryDellineObjectId);
    // имя класса для реализации
    $deliveryDellineObject->setValue("class_name", $className);
    //echo "deliveryDellineObjectId";
    //echo $deliveryDellineObjectId."<br/>";
 
    // связываем его с типом
    $deliveryDellineObject->setValue("delivery_type_id", $typeId);
    $deliveryDellineObject->setValue("delivery_type_guid", "user-emarket-delivery-" . $typeId);
    $deliveryDellineObject->commit();
 
    // Связываем внешний тип и внутренний объект
    $type = $objectTypesCollection->getType($typeId);
    $type->setGUID($deliveryDellineObject->getValue("delivery_type_guid"));
    //$typesCollection = umiObjectTypesCollection::getInstance();



    $type->commit();
